<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="formModel"
            :hidden-data="{
                id: formModel.id,
            }"
            :fields="formFields"
        />
        <div class="flex justify-end space-x-2">
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, onMounted, ref} from "vue";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";

const props = defineProps({
    formModel: {
        required: false,
        type: Object,
        default: null,
    }
});

const emit = defineEmits(['update']);

const $i18n = useI18n();
const pageReady = ref(false);
const form = ref();
const model = ref();
const selectOptions = ref([]);

const formFields = computed(() => {
    let field_name = 'setting_value';
    let field_label = $i18n.t('value');

    if (!model.value) return [];
    switch (model.value.setting_type) {
        case 'select':
            return [
                {
                    type: 'select',
                    name: 'setting_value',
                    label: $i18n.t('setting'),
                    placeholder: $i18n.t('please_select'),
                    options: selectOptions.value
                },
            ];
        case 'textarea':
            return [
                {
                    type: 'textarea',
                    name: field_name,
                    label: field_label,
                }
            ];
        case 'number':
            return [
                {
                    type: 'number',
                    name: field_name,
                    label: field_label,
                    number: true,
                }
            ];
        case 'fund':
            return [
                {
                    type: 'number',
                    name: field_name,
                    label: field_label,
                    fund: true
                }
            ];
        case 'editor':
            return [
                {
                    type: 'editor',
                    name: field_name,
                    label: field_label,
                    uploadImageUrl: '/other/setting/upload_image_by_file',
                }
            ];
        default:
            return [
                {
                    type: 'text',
                    name: field_name,
                    label: field_label,
                }
            ];
    }
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/other/setting/submit_form');

        if (resp.model) {
            emit('update', resp.model);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        const data = await axios.post('/other/setting/build_form', {
            id: props.formModel.id,
        });

        if (data.model) {
            model.value = data.model;
        }

        if (data.model.setting_type === 'select') {
            selectOptions.value = [];
            Object.keys(data.model.params).forEach(key => {
                selectOptions.value.push({
                    text: String(data.model.params[key]),
                    value: String(key),
                });
            });
        }

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
